.386
.model	flat, stdcall

option	casemap:none

;;	i n c l u d e s 	;;

include	f:\masm32\include\kernel32.inc
include	f:\masm32\include\user32.inc
include	f:\masm32\include\masm32.inc
include serpent_imp.asm	; serpent implementation

includelib f:\masm32\lib\user32.lib
includelib f:\masm32\lib\kernel32.lib
includelib f:\masm32\lib\masm32.lib

;;	p r o t o t y p e s	;;

main	PROTO

;;	m a c r o s	;;

print	macro	txt:REQ
	invoke	StdOut, addr txt
	endm

input	macro	prompt:REQ, buffer:REQ
	invoke	StdOut, addr prompt
	invoke	StdIn, addr buffer, lengthof buffer
	endm

;;	d a t a 	;;

.data
format		db "RESULT = %Xh",0
start_msg	db ":: Witeg Crackme #1 Serpent decryptor by bF!", 13, 10, 13, 10, 0
CRLF		db 0Ah, 0Dh, 0
input_text	db 100 dup(?)
Serial		db 100 dup(?)
kljuc		db "Try to crack this little crackme",0 ; serpent key
izlaz		dd 32 dup(0) ; decryption fill buffer
duzina		equ 256	; serpent key lenght
; what to decrypt, hardcoded in crackme!
ulaz            db 60h,2Dh,0Dh,0D9h,38h,0
                db 16h,0DAh, 72h,0C2h,0E0h,0C1h,0E6h,0A6h, 6Bh, 81h,0ABh, 67h, 67h
		db 0EBh,0AAh,0FFh,87h,0E8h, 23h,0C5h, 58h, 5Eh, 98h,0DDh, 26h,0E8h

;;	c o d e 	;;

.code

start:
	xor	eax, eax

	print	start_msg	; print start msg
	print	CRLF		; simulate enter

	; SET SERPENT KEY
	push	duzina		; lenght
	push	offset kljuc	; key
	call	_serpent_set_key; routine
 
        ; SERPENT DECRYPTION
	push	offset izlaz	; where to fill result
	push	offset ulaz	; what to decrypt
	call	_serpent_decrypt; routine

	mov	eax, [izlaz]	; result to eax
	xor	eax, 7B2D53EAh	; result xor 7B2D53EAh (last part of first mmx qword)

	invoke	wsprintfA, addr Serial, addr format, eax ; format serial for display

	input	Serial, input_text ; display the it and wait for Enter to be pressed

	invoke	ExitProcess, 0	; exit

end start